;---------------------------------------------------------------;
; Sample program for Using Animated Cursors and Animated Icons  ;
;                                                               ;
; Produced by:  Norman G. Cunningham - July 2003.               ;
;                                                               ;
; In developing this sample to demonstrate the use of my code   ;
; all common MASM coding and Windows functions were put into a  ;
; group of .INM files.  These files with the exception of       ;
; BASEWIN.INM will LIST in an assembly.                         ;
;                                                               ;
; These files are as Follows:                                   ;
;        BASEWIN.INM          - Basic Windows MASM Prolog       ;
;                               (includes etc.).                ;
;         WINPGD.INM          - Prolog globals (always first).  ;
;        UTILITY.INM          - The common utility FillBuffer.  ;
;        ANIICON.INM          - My routine for handling         ;
;                               Anumated Icons and Cursors.     ;
;        BASEDLG.INM          - The skeleton dialog box         ;
;                               procedure.                      ;
;        WINMAIN.INM          - The WinMain procedure for this  ;
;                               program.  Sets the window       ;
;                               background to match the desktop,;
;                               hope you don't use black!       ;
;         WINPGP.INM          - Standard MASM Windows prolog.   ;
;                                                               ;
; This was done to allow the user to view only the necessary    ;
; Animated Icon and Animated Cursor data, functions and access  ;
; methods. hopefully this will help.                            ;
;                                                               ;
; Norm                                                          ;
;---------------------------------------------------------------;
;
.NOLIST
.NOCREF
include BASEWIN.INM        ;Basic Windows MASM Prolog (includes etc.)
.LIST
include WINPGD.INM         ;Windows program prolog globals always first
include UTILITY.INM        ;The common utility FillBuffer
include ANIMRES.INC        ;Resource definitions for this program
include ANIICON.INM        ;My Animated Icon and Animated Cursor Routines
include BASEDLG.INM        ;Basic Dialog Procedure
;---------------------------------------------------------------;
; Used by WndProc to handle all Dialog Boxes                    ;
;---------------------------------------------------------------;
;
.code
AniDlgPass  proc  hWnd:HWND, vDialogID:DWORD
            invoke InitUserAniIcon
            invoke DialogBoxParam, hInstance, vDialogID, hWnd, ADDR DlgProc, NULL
            ret
AniDlgPass  Endp
;---------------------------------------------------------------;
; The WndProc for this program and its' .data with EQUATES      ;
;---------------------------------------------------------------;
;
.data
ICONBASE    equ   4000
ICONINDENT  equ   50
ICONLINE    equ   50

fSetCursor  DD 00h
hWindowCursor  DD 00h
hPrgClassCur   DD 00h

szExternalAni     db "'RailCrs.ANI'", 00h
szAniIconNamed    db "MyAniIcon", 00h
szAniCursorNamed  db "MyAniCursor", 00h
.code
WndProc  proc  hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
         LOCAL AniData:ANIRESOURCE_INFO
         LOCAL vIconID:DWORD, vWndx:DWORD, vWndy:DWORD
         .IF uMsg==WM_DESTROY
             invoke PostQuitMessage,NULL
         .ELSEIF  uMsg == WM_SETCURSOR
                  .IF   fSetCursor == 1
                        invoke SetCursor, hWindowCursor
                  .ELSE
                        invoke DefWindowProc,hWnd,uMsg,wParam,lParam
                        ret
                  .ENDIF
         .ELSEIF  uMsg == WM_CREATE
                  invoke GetClassLong, hWnd, GCL_HCURSOR
                  mov   hPrgClassCur, eax
         .ELSEIF  uMsg == WM_COMMAND
                  mov   eax, wParam
                  .IF   ax == IDM_ITEM19              ;Exit
                        invoke SendMessage, hWnd, WM_DESTROY, NULL, NULL
                  .ELSEIF  ax == IDM_ITEM20           ;About
                           invoke DialogBoxParam, hInstance, IDD_ABOUT, hWnd, ADDR DlgProc, NULL
                  ;-----------------------------------------------;
                  ;  This section does all Animated Icon Dialogs  ;
                  ;-----------------------------------------------;  
                  .ELSEIF  (ax >= IDM_ITEM01) && (ax <= IDM_ITEM06)
                           and   eax, 0000FFFFh
                           add   eax, 1000t
                           invoke AniDlgPass, hWnd, eax
                  ;-----------------------------------------------;
                  ;  This section handles Named Resource Cursors  ;
                  ;  Both Class Cursors and Window Cursors are    ;
                  ;  handled with the Class Cursor Restored for   ;
                  ;  window cursors and a flag set for window     ;
                  ;  cursors to process WN_SETCURSOR messages.    ;
                  ;-----------------------------------------------;
                  .ELSEIF  (ax == IDM_ITEM07 || ax == IDM_ITEM21) || \
                           (ax == IDM_ITEM10 || ax == IDM_ITEM24)
                           push eax
                           mov   eax, offset szAniIconNamed
                           invoke LoadAnimatedResource, hInstance, ADDR AniData, eax
                           .IF   eax == TRUE
                                 pop   eax
                                 .IF   (ax == IDM_ITEM07 || ax == IDM_ITEM10)
                                       .IF   fSetCursor == 1
                                             invoke SetCursor, hPrgClassCur
                                             invoke DestroyCursor, eax
                                       .ENDIF
                                       mov   fSetCursor, NULL
                                       invoke SetClassLong, hWnd, GCL_HCURSOR, AniData.hRAnimated
                                 .ELSE
                                       invoke SetClassLong, hWnd, GCL_HCURSOR, hPrgClassCur
                                       mov   eax, AniData.hRAnimated
                                       mov   hWindowCursor, eax
                                       invoke SetCursor, eax
                                       .IF   fSetCursor == 1
                                             invoke DestroyCursor, eax
                                       .ELSE
                                             mov   fSetCursor, 1
                                       .ENDIF
                                 .ENDIF
                           .ELSE
                                 pop   eax
                           .ENDIF
                  ;------------------------------------------------;
                  ;  This section handles Numbered Resource Cursors;
                  ;  Both Class Cursors and Window Cursors are     ;
                  ;  handled with the Class Cursor Restored for    ;
                  ;  window cursors and a flag set for window      ;
                  ;  cursors to process WN_SETCURSOR messages.     ;
                  ;------------------------------------------------;
                  .ELSEIF  (ax == IDM_ITEM08) || (ax == IDM_ITEM11) || \
                           (ax == IDM_ITEM22) || (ax == IDM_ITEM25)
                           push  eax
                           and   eax, 0000FFFFh
                           .IF   (ax == IDM_ITEM08) || (ax == IDM_ITEM11)
                                 add   eax, 3900t
                           .ELSE
                                 add   eax, 3880t
                           .ENDIF
                           invoke LoadAnimatedResource, hInstance, ADDR AniData, eax
                           .IF   eax == TRUE
                                 pop   eax
                                 .IF   (ax == IDM_ITEM08) || (ax == IDM_ITEM11)
                                       .IF   fSetCursor == 1
                                             invoke SetCursor, hPrgClassCur
                                             invoke DestroyCursor, eax
                                       .ENDIF
                                       mov   fSetCursor, NULL
                                       invoke SetClassLong, hWnd, GCL_HCURSOR, AniData.hRAnimated
                                 .ELSE
                                       invoke SetClassLong, hWnd, GCL_HCURSOR, hPrgClassCur
                                       mov   eax, AniData.hRAnimated
                                       mov   hWindowCursor, eax
                                       invoke SetCursor, eax
                                       .IF   fSetCursor == 1
                                             invoke DestroyCursor, eax
                                       .ELSE
                                             mov   fSetCursor, 1
                                       .ENDIF
                                 .ENDIF
                           .ELSE
                                 pop   eax
                           .ENDIF
                  ;-----------------------------------------------;
                  ;  This section handles External file Cursors   ;
                  ;  Both Class Cursors and Window Cursors are    ;
                  ;  handled with the Class Cursor Restored for   ;
                  ;  window cursors and a flag set for window     ;
                  ;  cursors to process WN_SETCURSOR messages.    ;
                  ;-----------------------------------------------;
                  .ELSEIF  (ax == IDM_ITEM09) || (ax == IDM_ITEM12) || \
                           (ax == IDM_ITEM23) || (ax == IDM_ITEM26)
                           push  eax 
                           mov   eax, offset szExternalAni
                           invoke LoadAnimatedResource, hInstance, ADDR AniData, eax
                           .IF   eax == TRUE
                                 pop   eax
                                 .IF   (ax == IDM_ITEM09) || (ax == IDM_ITEM12)
                                       .IF   fSetCursor == 1
                                             invoke SetCursor, hPrgClassCur
                                             invoke DestroyCursor, eax
                                       .ENDIF
                                       mov   fSetCursor, NULL
                                       invoke SetClassLong, hWnd, GCL_HCURSOR, AniData.hRAnimated
                                 .ELSE
                                       invoke SetClassLong, hWnd, GCL_HCURSOR, hPrgClassCur
                                       mov   eax, AniData.hRAnimated
                                       mov   hWindowCursor, eax
                                       invoke SetCursor, eax
                                       .IF   fSetCursor == 1
                                             invoke DestroyCursor, eax
                                       .ELSE
                                             mov   fSetCursor, 1
                                       .ENDIF
                                 .ENDIF
                           .ELSE
                                 pop   eax
                           .ENDIF
                  .ELSEIF  ax == IDM_ITEM27
                           invoke SetClassLong, hWnd, GCL_HCURSOR, hPrgClassCur
                           .IF   fSetCursor == 1
                                 invoke SetCursor, hPrgClassCur
                                 invoke DestroyCursor, eax
                                 mov   fSetCursor, NULL
                           .ENDIF
                  
                  .ELSEIF  ((ax >= IDM_ITEM13) && (ax <= IDM_ITEM18))
                           .IF   ((ax == IDM_ITEM14) || (ax == IDM_ITEM17))
                                 and   eax, 0000FFFFh
                                 mov   vIconID, ICONBASE
                                 add   vIconID, eax
                                 sub   vIconID, 200         ;Adjust internal
                                 sub   eax, IDM_ITEM13
                                 mov   vWndy, 10
                                 mov   vWndx, 10
                                 .IF   eax > 9
                                       add   vWndy, ICONLINE
                                       sub   eax, 10
                                 .ENDIF
                                 push  edx
                                 push  ecx
                                 xor   edx, edx
                                 mov   ecx, ICONINDENT
                                 mul   ecx
                                 pop   ecx
                                 pop   edx
                                 add   vWndx, eax
                                 invoke CreateAnimatedIcon, hWnd, vWndx, vWndy, vIconID, NULL
                              
                           .ELSEIF  ((ax == IDM_ITEM15) || (ax == IDM_ITEM18))
                                    and   eax, 0000FFFFh
                                    mov   vIconID, ICONBASE
                                    add   vIconID, eax
                                    sub   eax, IDM_ITEM13
                                    mov   vWndy, 10
                                    mov   vWndx, 10
                                    .IF   eax > 9
                                          add   vWndy, ICONLINE
                                          sub   eax, 10
                                    .ENDIF
                                    push  edx
                                    push  ecx
                                    xor   edx, edx
                                    mov   ecx, ICONINDENT
                                    mul   ecx
                                    pop   ecx
                                    pop   edx
                                    add   vWndx, eax
                                    invoke CreateAnimatedIcon, hWnd, vWndx, vWndy, vIconID, ADDR szExternalAni
                              
                           .ELSEIF  ((ax == IDM_ITEM13) || (ax == IDM_ITEM16))
                                    and   eax, 0000FFFFh
                                    push  eax
                                    mov   vIconID, ICONBASE
                                    add   vIconID, eax
                                    sub   eax, IDM_ITEM13
                                    mov   vWndy, 10
                                    mov   vWndx, 10
                                    .IF   eax > 9
                                          add   vWndy, ICONLINE
                                          sub   eax, 10
                                    .ENDIF
                                    push  edx
                                    push  ecx
                                    xor   edx, edx
                                    mov   ecx, ICONINDENT
                                    mul   ecx
                                    pop   ecx
                                    pop   edx
                                    add   vWndx, eax
                                    pop   eax
                                    .IF   ax == IDM_ITEM13
                                          invoke CreateAnimatedIcon, hWnd, vWndx, vWndy, vIconID, ADDR szAniIconNamed
                                    .ELSE
                                          invoke CreateAnimatedIcon, hWnd, vWndx, vWndy, vIconID, ADDR szAniCursorNamed
                                    .ENDIF
                           .ENDIF
                  .ENDIF
         .ELSE
               invoke DefWindowProc,hWnd,uMsg,wParam,lParam		
               ret
         .ENDIF
         xor eax,eax
         ret
WndProc  endp
;---------------------------------------------------------------;
; Data Here is used by WinMain to register the class and create ;
; the main window.                                              ;
;---------------------------------------------------------------;
;
.data
AppClass db "AniIconWinClass",0
AppName  db "Animated Icon Demonstration Program",0
;
include WINMAIN.INM  ; Windows WinMain procedure for the application
include WINPGP.INM   ; Windows program prolog
